# Export DICOM
# Copyright (c) 2006 Agfa HealthCare Inc.
# All rights reserved.
#
# Alain Barr AgfaPS (alain.barre@agfa.com)	Mai 2009	
# Clinical Viewing Integration Engineer | Professional service
# T  +32 3444 9388 | M  +32 494 560505
# Agfa HealthCare NV, Septestraat 27, B-2640 Mortsel, Belgium

# This wizard will export the series of the clicked  image to a folder/file structure located under ExportRoot
# $Revision: 1.0 $
#

# Turn debugging on (1) or off (0)
set debug_wizard 0


# cache location (default is c:\temp) - don't forget the extra "\"
# Alain Barre: Cache will be build dynamically
# Adaptation : Michael Dolores (Rouen FR) - Yves Gandon (Rennes FR) 

set cache ""
set DriveLetter "C:"
set ExportRoot "MRQuantIF\\\\FromPACS"



# Get a list of series in the selected study
set study_list [get_studies selected]
set study [lindex $study_list 0]
set series_list [get_series $study]
set series_cur [get_series selected]

# New variables for absolute path 
set PatName [get_info patient_name [get_images selected]]
set PatId [get_info patient_id [get_images selected]]
set AccNbr [get_info study_accession_number [get_images selected]]


# helpers for concatenation
set cache ""
set bsc "\\\\"
set obc "("
set cbc ")"
set fex ".dcm"

# lets build the relative path to the serie folder
set Cache "OP"

# Cleanup for invalid characters
for {set x 0} {$x < 5} {incr x} {
  set Cache [string map {" " "_" ":" "_" "[" "_" "]" "_" "?" "_" "*" "_" "," "_" "^" "_" "__" "_"} $Cache]
}

# Building root path
set Cache "$DriveLetter$bsc$ExportRoot$bsc"
if { $debug_wizard } { puts $log_file "RootCache:          $Cache" }



# create the directory
file mkdir $Cache



#lets scan the Serie List
set cnt 1
foreach series $series_list {

	# check if this is the series selected
	if { $series == $series_cur} {
    
		# lets get the  images of this series in a list
		set image_list [get_images [get_series $series]]
	
	
		# and get the nbr of images
		set images_nbr [llength $image_list]
		if { $debug_wizard } {puts $log_file "    series:          $series$obc$cnt$cbc  ImgNbr:$images_nbr"}


		#lets build the full cache path for teh series
		set ser "Serie"
		#set SeriesCache "$Cache$bsc$ser$obc$cnt$cbc"
                set SeriesCache "$Cache"
		if { $debug_wizard } {puts $log_file "    AbsCache4Series: $SeriesCache" }

		# create the directory
		file mkdir $SeriesCache

		for {set i 1} {$i <= $images_nbr } { incr i } {   

			#{ 7 2 3 1 } will specify the Image in Series in Study context applied 
			# to the second image of the third series of the first study).

			set context "{ 7 $i $cnt 1 }"
			if { $debug_wizard } {puts $log_file "      context:       $context"}
			set SUID [get_info series_uid [get_images selected]]
			if { $debug_wizard } {puts $log_file "      SUID:          $SUID"}
		  
			#export the image
		 
			set len [string length $i]
			switch $len {
				1 {set ImageName "Img0000$i"}
				2 {set ImageName "Img000$i"}
				3 {set ImageName "Img00$i"}
				4 {set ImageName "Img0$i"}
				5 {set ImageName "Img$i"}

			}

			if { $debug_wizard } {puts $log_file "      ImageName:     $ImageName"}
			if { $debug_wizard } {puts $log_file "      SOP:           $SeriesCache$bsc$ImageName$fex"}
			
			#lets call teh wizard
			wizard export_dcm_image $context "$SeriesCache$bsc$ImageName$fex"


		}




	} else {
	
		if { $debug_wizard } {puts $log_file "    series:          $series$obc$cnt$cbc"}
	
	}




	incr cnt
}


# Clean up any outstanding references
destroy_token all

if { $debug_wizard } {close $log_file}
# call notification
#exec wscript c:/AgfaPS/mStickExport/notification.vbs $AccNbr
exec wscript C:/MRQuantIF/MRQuantif.vbs